Import "State.bmx"
Type StateMachine

	Field states:TList
	Field active_state:State
	
	Method New()
		states = New TList
		active_state = Null
	End Method
	
	Method add_state(s:State)
		ListAddLast(Self.states, s)
	End Method
	
	Method think()
		If (Self.active_state = Null)
			Return
		EndIf
		Self.active_state.do_actions()
		new_state:State = active_state.check_conditions()	
		If (new_state <> Null)
			Self.set_state(new_state.name)
		EndIf
	End Method
	
	Method set_state(name:String)
		If (name = Null)
			Self.active_state = Null
			Return
		EndIf
		If (Self.active_state)
			Self.active_state.exit_actions()
		EndIf
		Local found% = False;
		For Local s:State=EachIn Self.states
			If (s.check_name(name))
				'Print " setting a new state: " + name
				Self.active_state = s
				Self.active_state.entry_actions
				found = True;
			EndIf
		Next
		If (Not found) Print "Warning! Cannot find state: " + name
	End Method
End Type
